/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.Map;

import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.HubunganKeluarga;
import com.portofolio.entity.vo.HubunganKeluargaId;

@Lazy
@Repository
public interface HubunganKeluargaDao extends CrudRepository<HubunganKeluarga, HubunganKeluargaId> {

	@Query(QListAll)
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("statusEnabled") boolean statusEnabled, Pageable page);

	@Query(QListAll + " and model.namaHubunganKeluarga like %:namaHubunganKeluarga% ")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile,@Param("namaHubunganKeluarga") String namaHubunganKeluarga, @Param("statusEnabled") boolean statusEnabled,Pageable page);

	@Query(QListAll + " and model.id.kdHubunganKeluarga = :kdHubunganKeluarga")
	Map<String, Object> findByKdHubunganKeluarga(@Param("kdProfile") Integer kdProfile,@Param("kdHubunganKeluarga") Integer kdHubunganKeluarga, @Param("statusEnabled") boolean statusEnabled);

    
    
    String QListAll ="select new map(model.id.kdHubunganKeluarga as kdKdHubunganKeluarga,model.id.kdProfile as kdProfile "
            + ", model.namaHubunganKeluarga as namaHubunganKeluarga " 
            + ", model.reportDisplay as reportDisplay " 
            + ", model.kodeExternal as kodeExternal " 
            + ", model.namaExternal as namaExternal " 
            + ", model.statusEnabled as statusEnabled " 
            + ", model.noRec as noRec " 
            + ", model.version as version )" 
            + " from HubunganKeluarga model left join model.id id "
            + " where id.kdProfile=:kdProfile "
            + " and model.statusEnabled = :statusEnabled "; 

}
